{

  ࠡ  FidoNet CFG/CTL/etc 䠩 䨣樨
Copyright (c) 1999, Beta Technologies

Copyright (c) 1999, Vladimir Zaytcev, 2:5015/116@fidonet

}


{$IFDEF DPMI}{$DEFINE DOS}{$ENDIF}
{$IFDEF MSDOS}{$DEFINE DOS}{$ENDIF}
{$IFDEF WIN32}{$DEFINE W32}{$ENDIF}
{$IFDEF VIRTUALPASCAL}{$DEFINE VP}{$ENDIF}

Unit BConfig;

Interface

uses Dos, Objects, BUtils;

type

 PConfigRec  = ^TConfigRec;
 TConfigRec  = Object (TObject)
              Parameter : String[50];
              Value     : String[255];
              Line      : integer;
              constructor Init(P, V :String; L: integer);
              destructor  Done; virtual;
            end;

 TBConfig = object (TObject)
        constructor Create(FileName :String);
        destructor  Free; virtual;
        function    ReadValue(Parameter, StrDefault :string; var Line: Integer): string; virtual;
        function    ReadValueNumber(Parameter, StrDefault :string; ValueNumber: Integer; var Line: Integer): string; virtual;
        function    ParamName(Number: Integer; var Line: Integer): string; virtual;
        function    ReadBoolean(Parameter: string; Default :boolean; var Line: Integer): boolean; virtual;
        function    ValueExists(Parameter :string; var Line: Integer): boolean; virtual;
        function    ValueCount(Parameter :string): integer; virtual;
        function    RecCount: integer; virtual;
        function    ParseConfig: boolean; virtual;
        procedure   ShowAllValues;
 private
        Config  :text;
        PConfig: PCollection;
        PRec : PConfigRec;
        fName :string;
        RecordsCount: integer;
 public
        Opened      :boolean;
end;

const
     CommentChar = ';';

implementation

constructor TConfigRec.Init(P, V :String; L: integer);
 begin
   Parameter:=P;
   Value:=V;
   Line:=L;
 end;

destructor  TConfigRec.Done;
begin
end;

constructor TBConfig.Create(filename: String);
 begin
   if fileexists(filename) then
     begin
       inherited Init;
       fName := filename;
       Opened:=True;
       New(PConfig,Init(0,1));
       ParseConfig;
     end;
 end;

destructor TBConfig.Free;
 begin
   if opened then Dispose(PConfig);
   inherited Done;
 end;

function TBConfig.ReadValue(Parameter, StrDefault : string; var Line: Integer): string;
var
   count:integer;
 begin
   ReadValue:=StrDefault;
   Line  := 0;
   if Opened then
     begin
       for count:=0 to PConfig^.Count-1 do
         begin
           PRec:=PConfig^.At(Count);
           If LowerCase(PRec^.Parameter)=LowerCase(Parameter) then
           begin
             ReadValue := PRec^.Value;
             Line  := PRec^.Line;
           end;
         end;
     end;
 end;

function  TBConfig.ReadBoolean(Parameter: string; Default :boolean; var Line: Integer): boolean;
var
   count:integer;
 begin
   ReadBoolean:=Default;
   Line  := 0;
   if Opened then
     begin
       for count:=0 to PConfig^.Count-1 do
         begin
           PRec:=PConfig^.At(Count);
           If LowerCase(PRec^.Parameter)=LowerCase(Parameter) then
             begin
               if ((LowerCase(PRec^.Value)='yes') or
                   (LowerCase(PRec^.Value)='true')) then
                   begin
                     ReadBoolean := true;
                     Line := PRec^.Line;
                   end
               else
                   if ((LowerCase(PRec^.Value)='no') or
                   (LowerCase(PRec^.Value)='false')) then
                   begin
                     ReadBoolean := false;
                     Line  := PRec^.Line;
                   end;
             end;
         end;
     end;
 end;

function TBConfig.ReadValueNumber(Parameter, StrDefault: string; ValueNumber: Integer; var Line: Integer): string;
var
   Count, VCount: integer;
 begin
   ReadValueNumber := StrDefault;
   VCount := 0; Line  := 0;
   if Opened then
     begin
       for count:=0 to PConfig^.Count-1 do
         begin
           PRec:=PConfig^.At(Count);
           If LowerCase(PRec^.Parameter)=LowerCase(Parameter) then
             begin
               Inc(VCount);
               If VCount=ValueNumber then
                 begin
                   ReadValueNumber := PRec^.Value;
                   Line  := PRec^.Line;
                 end;
             end;
         end;
     end;
 end;

function TBConfig.ParamName(Number: Integer; var Line: Integer): string;
 begin
   Line := 0; ParamName := '';
   if Opened then
     begin
       PRec:=PConfig^.At(Number-1);
       ParamName := PRec^.Parameter;
       Line := PRec^.Line;
     end;
 end;

function TBConfig.ValueExists(Parameter : string; var Line: Integer): boolean;
var
   count:integer;
 begin
  ValueExists := False;
  Line  := 0;
  if Opened then
    begin
      for count:=0 to PConfig^.Count-1 do
        begin
          PRec:=PConfig^.At(Count);
          If LowerCase(PRec^.Parameter)=LowerCase(Parameter) then
            begin
              ValueExists := true;
              Line  := PRec^.Line;
            end;
        end;
    end;
 end;

function TBConfig.ValueCount(Parameter : string): integer;
var
   Count, ValuesFound :integer;
 begin
   ValuesFound := 0;
   if Opened then
     begin
      for count:=0 to PConfig^.Count-1 do
        begin
          PRec:=PConfig^.At(Count);
          If LowerCase(PRec^.Parameter)=LowerCase(Parameter)
          then Inc(ValuesFound);
        end;
       ValueCount := ValuesFound;
     end;
 end;

function TBConfig.ParseConfig: boolean;
var
   Str: string; linecount, count:integer;
   P, V: String;
 begin
   if Opened then
     begin
       LineCount := 0; RecordsCount := 0;
       Assign(Config,fName);
       Reset(Config);
       ParseConfig := True;
       while not eof(Config) do
         begin
           Inc(LineCount);
           readln(Config, str);
           if boolean(pos(CommentChar,str)) then
           Delete(str,pos(CommentChar,str),length(str));
           for count:=1 to length(str) do
           if str[count]<>char(32) then break;
           Delete(str,1,count-1);
           for count:=length(str) downto 1 do
           if str[count]<>char(32) then break;
           Delete(str,count+1,length(str));

           if boolean(Length(str)) then
             begin
               if Pos(Char(32), Str)<>0
               then P := Copy(Str,1,Pos(Char(32),Str)-1)
               else
                 begin
                   P := Copy(Str,1,Length(Str));
                   WriteLn('Parameter "',P,'"',' at line ',LineCount,' is without value');
                   Close(Config);
                   Halt;
                 end;
               Delete(Str,1,Pos(Char(32),Str));
               for count:=1 to length(str) do
               if str[count]<>char(32) then break;
               V := copy(str,count,length(str));;
               PConfig^.Insert(New(PConfigRec,Init(P,V,LineCount)));
             end;
           end;
         Close(Config);
         RecordsCount:=PConfig^.Count;
       end;
 end;

function TBConfig.RecCount: integer;
 begin
   RecCount := PConfig^.Count;
 end;

procedure TBConfig.ShowAllValues;
var
   count: integer;
 begin
   if Opened then
      for count:=0 to PConfig^.Count-1 do
        begin
          PRec:=PConfig^.At(Count);
          WriteLn(PRec^.Parameter,' = ',PRec^.Value,' at line ', PRec^.Line);
       end;
 end;

end.
