{

Unit for working with CRC32

Autor is unknown,
Modified in 1998 by Vladimir Zaytcev, 2:5015/116@fidonet

last modified 01/09/1999:
added function TimeCRC32 for making CRC32 of current datetime. this function
can be used for creating non-repeat filename of packet/bundle.

}

{$IFDEF VIRTUALPASCAL}{$DEFINE VP}{$ENDIF}

Unit BCRC32;

Interface

uses Dos, BUtils;

Procedure MakeCRCTable;
Function  RecountCRC(b : Byte; CrcOld : Longint) : Longint;
Function  HextW(w : Word) : String;
Function  HextL(l : Longint) : String;
Function  GetCRC32Str(filename:String):String;
Function GetCRC32Int(filename:String):Longint;
Function TimeCRC32:String;

Implementation

Type
  Long = Record
    Loword : Word;
    Hiword : Word;
  End;

Const
  CRCPOLY = $EDB88320;

Var
  CRCTable  : Array[0..512] Of Longint;


Procedure MakeCRCTable;
Var
  i, j : Word;
  r    : Longint;
Begin
  FillChar(CRCTable, SizeOf(CRCTable), 0);
  For i:=0 To 255 Do
   Begin
    r:=i Shl 1;
    For j:=8 DownTo 0 do
      If (r and 1)<>0 Then
        r:=(r Shr 1) Xor CRCPOLY
      Else
        r:=r Shr 1;
    CRCTable[i]:=r;
   End;
End;

Function RecountCRC(b : byte; CrcOld : Longint) : Longint;
Begin
   RecountCRC:=CRCtable[byte(CrcOld xor longint(b))] xor ((CrcOld shr 8) And
$00FFFFFF)
End;

Function HextW(w : Word) : String;
Const
  h : Array[0..15] Of Char = '0123456789ABCDEF';
Begin
  HextW:='';
  HextW:=h[Hi(w) Shr 4]+h[Hi(w) And $F]+h[Lo(w) Shr 4]+h[Lo(w) And $F];
End;

Function HextL(l : Longint) : String;
Begin
  With Long(l) Do
    HextL:=HextW(HiWord)+HextW(LoWord);
End;

Function GetCRC32Str(filename:String):String;
Var
  Buffer: PChar;
  f     : File;
  b     : Array[0..255] Of Byte;
  CRC{$IFDEF VP}, e {$ENDIF}: Longint;
  i {$IFNDEF VP} , e{$ENDIF} : Integer;

Begin
  MakeCRCTable;
  CRC := $FFFFFFFF;
  if FileExists(filename) then
    begin
      Assign(F,filename);
      Reset(F,1);
      GetMem(Buffer,SizeOf(B));
      Repeat
        FillChar(b, SizeOf(b), 0);
        BlockRead(F, b,SizeOf(b), e);
        For i := 0 To (e-1) Do CRC := RecountCRC (b[i], CRC);
      Until (e < 255) Or (IOresult <> 0);
      FreeMem(Buffer,SizeOf(B));
      Close(F);
   end;
  CRC := Not CRC;
  GetCRC32Str:='$'+HextL(CRC);
end;

Function GetCRC32Int(filename:String):LongInt;
Var
  Buffer: PChar;
  f     : File;
  b     : Array[0..255] Of Byte;
  CRC{$IFDEF VP}, e {$ENDIF}: Longint;
  i {$IFNDEF VP} , e{$ENDIF} : Integer;
Begin
  MakeCRCTable;
  CRC := $FFFFFFFF;
  If FileExists(filename) then
    begin
      Assign(F,filename);
      Reset(F,1);
      GetMem(Buffer,SizeOf(B));
      Repeat
        FillChar(b, SizeOf(b), 0);
        BlockRead(F, b,SizeOf(b), e);
        For i := 0 To (e-1) Do CRC := RecountCRC (b[i], CRC);
      Until (e < 255) Or (IOresult <> 0);
      FreeMem(Buffer,SizeOf(B));
      Close(F);
    end;
  CRC := Not CRC;
  GetCRC32Int:=CRC;
end;

Function TimeCRC32:String;
Var
  CRC: Longint;
  count: integer;
  TimeStr: string; h,m,s,ms,y,mn,d,dow: word;

Begin
  MakeCRCTable;
  GetTime(h,m,s,ms);
  GetDate(y,mn,d,dow);
  TimeStr:=IntToStr(d)+IntToStr(mn)+IntToStr(y)+IntToStr(h)+IntToStr(m)+IntToStr(s)+IntToStr(ms);
  for count := 1 to length(TimeStr) do CRC := RecountCRC (ord(TimeStr[count]), CRC);
  CRC := Not CRC;
  TimeCRC32:=HextL(CRC);
end;

end.
