{

 ࠧ 楤  㭪権  FTN-ware
Copyright (c) 1999, Beta Technologies

Copyright (c) 1999, Vladimir Zaytcev, 2:5015/116@fidonet

㭪樨 IntToDuotric (Duotrycenary)  Addr2Bink    t-api.pas
(T-Mail 2600-2606 API, Main Pascal unit)
(c) Jef (2:5030/339), St.Petersburg, 1997
(c) Anton Krenitskiy (2:5030/339.21), St.Petersburg, 1997
(c) Yoletir (2:5030/654), St.Petersburg, 1998

}

{$IFDEF DPMI}{$DEFINE DOS}{$ENDIF}
{$IFDEF MSDOS}{$DEFINE DOS}{$ENDIF}
{$IFDEF WIN32}{$DEFINE W32}{$ENDIF}
{$IFDEF VIRTUALPASCAL}{$DEFINE VP}{$ENDIF}
{$S-,R-,I-,V-,B-}

Unit BFTNUtil;

Interface

uses Dos, BUtils {$IFDEF VP},use32{$ENDIF};
{$F+}

type
    PFTNAddress = ^FTNAddress;
    FTNAddress = record
                   zone,
                   net,
                   node,
                   point : Longint;
                   domain : string[8];
                 end;
const
    BundleExt : array [0..6] of string[2] = ('mo','tu','we','th','fr','sa','su');

procedure Str2Addr(AddrStr: string; var Addr:FTNAddress);
procedure AddrMask(AddrStr: string; Addr: FTNAddress; var Mask: FTNAddress);
function Addr2Str(Link: FTNAddress):string;
function Addr2Str5d(Link: FTNAddress):string;
function Addr2Bink (Addr: FTNAddress) : string;
function CompareAddr(MaskAddr, CheckAddr: FTNAddress): boolean;
function IntToDuotric (i, digits : word): String;
function DuotricToInt(S: String): Longint;

function CheckBB(boxdir: string):boolean;
procedure BBAddr(dir: string; var Addr:FTNAddress);
function BBStatus(dir: string): string;

function CheckSTB(boxdir: string):boolean;
procedure STBAddr(dir: string; var Addr:FTNAddress);
function STBStatus(dir: string): string;

function CheckLTB(boxdir: string):boolean;
procedure LTBAddr(dir: string; var Addr:FTNAddress);
function LTBStatus(dir: string): string;

function BoxFilesSize(dir: string): Longint;
function BoxFilesCount(dir: string): Integer;
function OldestFileDate(dir: string): PDateTime;
function EarlierFileDate(dir: string): PDateTime;

function IsBundle(filename: string):boolean;
function IsLo(filename: string):boolean;
function IsUt(filename: string):boolean;
function IsPkt(filename: string):boolean;

function LoFlavour(filename: string):string;
function UtFlavour(filename: string):string;

Implementation

procedure Str2Addr(AddrStr: string; var Addr:FTNAddress);
 begin
   Addr.Zone := StrToInt(Copy(AddrStr,1,pos(':',AddrStr)-1));
   AddrStr := Copy(AddrStr,pos(':',AddrStr)+1, length(AddrStr));
   Addr.Net := StrToInt(Copy(AddrStr,1,pos('/',AddrStr)-1));
   AddrStr := Copy(AddrStr,pos('/',AddrStr)+1, length(AddrStr));
   if pos('@',AddrStr)<>0 then
   if pos('.',AddrStr)=0 then
     begin
       Addr.Node := StrToInt(Copy(AddrStr,1,pos('@',AddrStr)-1));
       Addr.Point := 0;
       Addr.Domain := Copy(AddrStr,pos('@',AddrStr)+1,8)
     end
   else
     begin
       Addr.Node := StrToInt(Copy(AddrStr,1,pos('.',AddrStr)-1));
       AddrStr := Copy(AddrStr,pos('.',AddrStr)+1, pos('@',AddrStr));
       Addr.Point := StrToInt(Copy(AddrStr,1,pos('@',AddrStr)-1));
       Addr.Domain := Copy(AddrStr,pos('@',AddrStr)+1,8)
     end
   else
   if pos('.',AddrStr)=0 then
     begin
       Addr.Node := StrToInt(Copy(AddrStr,1,length(AddrStr)));
       Addr.Point := 0;
       Addr.Domain :=  'fidonet';
     end
   else
     begin
       Addr.Node := StrToInt(Copy(AddrStr,1,pos('.',AddrStr)-1));
       AddrStr := Copy(AddrStr,pos('.',AddrStr)+1, length(AddrStr));
       Addr.Point := StrToInt(Copy(AddrStr,1,length(AddrStr)));
       Addr.Domain := 'fidonet';
     end;
 end;

procedure AddrMask(AddrStr: string; Addr: FTNAddress; var Mask: FTNAddress);
 begin
   if Copy(AddrStr,1,pos(':',AddrStr)-1)='*' then Mask.Zone := -1 else
   if Copy(AddrStr,1,pos(':',AddrStr)-1)='#' then Mask.Zone := Addr.Zone else
   Mask.Zone := StrToInt(Copy(AddrStr,1,pos(':',AddrStr)-1));
   AddrStr := Copy(AddrStr,pos(':',AddrStr)+1, length(AddrStr));

   if Copy(AddrStr,1,pos('/',AddrStr)-1)='*' then Mask.Net := -1 else
   if Copy(AddrStr,1,pos('/',AddrStr)-1)='#' then Mask.Net := Addr.Net else
   Mask.Net := StrToInt(Copy(AddrStr,1,pos('/',AddrStr)-1));
   AddrStr := Copy(AddrStr,pos('/',AddrStr)+1, length(AddrStr));
   if pos('.',AddrStr)=0 then
     begin
       if Copy(AddrStr,1,Length(AddrStr))='*' then Mask.Node := -1 else
       if Copy(AddrStr,1,Length(AddrStr))='#' then Mask.Node := Addr.Node else
       Mask.Node := StrToInt(Copy(AddrStr,1,Length(AddrStr)));
       Mask.Point := 0;
     end
   else
     begin
       if Copy(AddrStr,1,pos('.',AddrStr)-1)='*' then Mask.Node := -1 else
       if Copy(AddrStr,1,pos('.',AddrStr)-1)='#' then Mask.Node := Addr.Node else
       Mask.Node := StrToInt(Copy(AddrStr,1,pos('.',AddrStr)-1));
       AddrStr := Copy(AddrStr,pos('.',AddrStr)+1, length(AddrStr));
       if AddrStr='*' then Mask.Point := -1 else
       Mask.Point := StrToInt(AddrStr);
     end;
 end;

function Addr2Str(Link: FTNAddress):string;
var
   AddrStr: String;
 begin
   AddrStr := IntToStr(Link.Zone)+':'+
              IntToStr(Link.Net) +'/'+
              IntToStr(Link.Node);
   If Link.Point<>0 then AddrStr:=AddrStr+'.'+IntToStr(Link.Point);
   Addr2Str := AddrStr;
 end;

function Addr2Str5d(Link: FTNAddress):string;
 begin
   Addr2Str5d := Addr2Str(Link)+'@'+Link.Domain;
 end;

function Addr2StrDomain(Link: FTNAddress):string;
 begin
   Addr2StrDomain :=
               IntToStr(Link.Zone)+':'+
               IntToStr(Link.Net) +'/'+
               IntToStr(Link.Node)+'.'+
               IntToStr(Link.Point)+'@'+
               Link.Domain;
 end;

function Addr2Bink (Addr: FTNAddress) : string;
 begin
    if Addr.point = 0 then
      Addr2Bink := IntToHex (Addr.net, 4) + IntToHex (Addr.node, 4)
    else
      Addr2Bink :=  IntToHex (Addr.net, 4) + IntToHex (Addr.node, 4) +
          '.PNT\' + IntToHex (Addr.point, 8);
 end;

procedure BBAddr(dir: string; var Addr:FTNAddress);
 begin
   Addr.Domain:=Copy(dir,1,pos('.',dir)-1);
   delete(dir,1,pos('.',dir));
   Addr.Zone:=StrToInt(Copy(dir,1,pos('.',dir)-1));
   delete(dir,1,pos('.',dir));
   Addr.Net:=StrToInt(Copy(dir,1,pos('.',dir)-1));
   delete(dir,1,pos('.',dir));
   Addr.Node:=StrToInt(Copy(dir,1,pos('.',dir)-1));
   delete(dir,1,pos('.',dir));
   Addr.Point:=StrToInt(Copy(dir,1,pos('.',dir)-1));
   delete(dir,1,pos('.',dir));
 end;

function BBStatus(dir: string): string;
 begin
  BBStatus:=Copy(dir,LastPos('.',dir)+1,Length(dir));
 end;

function CompareAddr(MaskAddr, CheckAddr: FTNAddress): boolean;
var Rslt : boolean;
 begin
   Rslt := true;
   if ((Rslt) and ((MaskAddr.Zone=-1)  or (MaskAddr.Zone=CheckAddr.Zone)))   then else Rslt := false;
   if ((Rslt) and ((MaskAddr.Net=-1)   or (MaskAddr.Net=CheckAddr.Net)))     then else Rslt := false;
   if ((Rslt) and ((MaskAddr.Node=-1)  or (MaskAddr.Node=CheckAddr.Node)))   then else Rslt := false;
   if ((Rslt) and ((MaskAddr.Point=-1) or (MaskAddr.Point=CheckAddr.Point))) then else Rslt := false;
   CompareAddr:=Rslt;
 end;

function CheckBB(boxdir: string):boolean;
const
      AvailBoxChars  : string = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.';
var
   count, point: integer;
 begin
      CheckBB:=true; point:=0;
      for count:=1 to length(boxdir) do
      if pos(boxdir[count],AvailBoxChars)=0 then CheckBB:=false;
      for count:=1 to length(boxdir) do
      if boxdir[count]='.' then inc(point);
      if (point<>5) or ((boxdir='.') or (boxdir='..')) then CheckBB:=false;
 end;


const
      DuotricTable : string = '0123456789ABCDEFGHIJKLMNOPQRSTUV';

function IntToDuotric (i, digits : word): String;
var
{$IFNDEF VP}
  Result : string;
{$ENDIF}
  b, j : integer;
begin
  {$IFDEF VP}
  SetLength (Result, digits);
  {$ELSE}
  byte (Result [0]) := digits;
  {$ENDIF}
  for j := 1 to digits do
  begin
    b := i AND 31;
    Result [digits-j+1] := DuotricTable [b+1];
    i := i SHR 5;
  end;
  IntToDuotric := Result;
end;

function DuotricToInt(S: String): Longint;
var
   Base, Rslt: Longint;
   Count: Integer; DTS: String;
 begin
   Base := 32; DTS := UpperCase(S); Rslt := 0;
   for Count:=1 to Length(DTS)-2 do Base := (32*Base);
   for Count:=1 to Length(DTS) do
   if Pos(DTS[Count],DuotricTable)<>0 then
     begin
       Rslt := Rslt + (Pos(DTS[Count],DuotricTable)-1)*Base;
       Base:= Base div 32; if Base = 0 then Base:=1;
     end;
   DuotricToInt := Rslt;
 end;

function CheckSTB(boxdir: string):boolean;
const
      AvailBoxChars  : string = 'abcdefghijklmnopqrstuvABCDEFGHIJKLMNOPQRSTUV0123456789.';
var
   count, point: integer;
 begin
      CheckSTB:=true; point:=0;
      for count:=1 to length(boxdir) do
      if not (length(boxdir) in [11..12]) then CheckSTB:=false;
      if pos(boxdir[count],AvailBoxChars)=0 then CheckSTB:=false;
      for count:=1 to length(boxdir) do
      if boxdir[count]='.' then inc(point);
      if ((point>1) or (point=0)) or ((boxdir='.') or (boxdir='..')) then CheckSTB:=false;
 end;


procedure STBAddr(dir: string; var Addr:FTNAddress);
 begin
   Addr.Zone  := DuotricToInt(Copy(dir,1,2));
   Addr.Net   := DuotricToInt(Copy(dir,3,3));
   Addr.Node  := DuotricToInt(Copy(dir,6,3));
   Addr.Point := DuotricToInt(Copy(dir,pos('.',dir)+1,2));
   Addr.Domain:='';
 end;

function STBStatus(dir: string): string;
 begin
     if ((dir[Length(dir)]='H') or (dir[Length(dir)]='h'))
        then STBStatus := 'hold'
     else STBStatus := 'normal'
end;

function BoxFilesCount(dir: string): Integer;
var
   SR: SearchRec;
   fCount, SearchResult: Integer;
 begin
   fCount:=0;
   FindFirst(AddBackSlash(Dir)+'*.*', Archive, SR);
     while DosError = 0 do
       begin
         Inc(fCount);
         FindNext(SR);
       end;
   BoxFilesCount := fCount;
 end;

function BoxFilesSize(dir: string): Longint;
var
   SR: SearchRec;
   S: longint;
 begin
   S:=0;
   FindFirst(AddBackSlash(Dir)+'*.*', Archive, SR);
     while DosError = 0 do
       begin
         S:=S+SR.Size;
         FindNext(SR);
       end;
   BoxFilesSize := S;
 end;

function OldestFileDate(dir: string): PDateTime;
var
   SR: SearchRec;
   CTime: longint; CT: PDateTime;
 begin
    GetMem(CT, SizeOf(DateTime));
    CT:=CurrDateTime;
    PackTime(CT^, CTime);
    FindFirst(AddBackSlash(Dir)+'*', Archive, SR);
     while DosError = 0 do
       begin
         if SR.Time<CTime then CTime:=SR.Time;
         FindNext(SR);
       end;
   if CTime<>0 then UnpackTime(CTime, CT^);
   OldestFileDate := CT;
 end;

function EarlierFileDate(dir: string): PDateTime;
var
   SR: SearchRec;
   CTime: longint; CT: PDateTime;
 begin
   CT^.Year:=0; CT^.Month:=0; CT^.Day:=0;
   CT^.Hour:=0; CT^.Min  :=0; CT^.sec:=0;
   GetMem(CT, SizeOf(DateTime));
   PackTime(CT^, CTime);
   FindFirst(AddBackSlash(Dir)+'*', Archive, SR);
     while DosError = 0 do
       begin
         if SR.Time>CTime then CTime:=SR.Time;
         FindNext(SR);
       end;
   if CTime<>0 then UnpackTime(CTime, CT^);
   EarlierFileDate := CT;
 end;

function IsBundle(filename: string):boolean;
var
   count: integer; res: boolean;
 begin
   res := false;
   for count:=0 to 6 do
   if LowerCase(Copy(filename,LastPos('.',filename)+1,2))=BundleExt[count]
   then begin res := true; Break; end;
   IsBundle := res;
 end;

function IsLo(filename: string):boolean;
 begin
   IsLo := false;
   if LowerCase(Copy(filename,LastPos('.',filename)+2,2))='lo'
   then IsLo := true;
 end;

function IsPkt(filename: string):boolean;
 begin
   IsPkt := false;
   if LowerCase(Copy(filename,LastPos('.',filename)+1,3))='pkt'
   then IsPkt := true;
 end;

function IsUt(filename: string):boolean;
 begin
   IsUt := false;
   if LowerCase(Copy(filename,LastPos('.',filename)+2,2))='ut'
   then IsUt := true;
 end;

function LoFlavour(filename: string):string;
var
   S: String;
 begin
   S := LowerCase(filename);
   if S[LastPos('.',filename)+1]='h' then LoFlavour := 'hold'       else
   if S[LastPos('.',filename)+1]='c' then LoFlavour := 'crash'      else
   if S[LastPos('.',filename)+1]='i' then LoFlavour := 'immediate'  else
   if S[LastPos('.',filename)+1]='d' then LoFlavour := 'direct'     else
   if S[LastPos('.',filename)+1]='f' then LoFlavour := 'normal'     else
   LoFlavour :='unknown';
 end;


function UtFlavour(filename: string):string;
var
   S: String;
 begin
   S := LowerCase(filename);
   if S[LastPos('.',filename)+1]='h' then UtFlavour := 'hold'       else
   if S[LastPos('.',filename)+1]='c' then UtFlavour := 'crash'      else
   if S[LastPos('.',filename)+1]='i' then UtFlavour := 'immediate'  else
   if S[LastPos('.',filename)+1]='d' then UtFlavour := 'direct'     else
   if S[LastPos('.',filename)+1]='o' then UtFlavour := 'normal'     else
   UtFlavour :='unknown';
 end;

function CheckLTB(boxdir: string):boolean;
const
      AvailBoxChars  : string = 'hH0123456789.';
var
   count, point: integer;
 begin
   CheckLTB:=true; point:=0;
   for count:=1 to length(boxdir) do
   if pos(boxdir[count],AvailBoxChars)=0 then CheckLTB:=false;
   for count:=1 to length(boxdir) do
   if boxdir[count]='.' then inc(point);
   if ((point<>3) and (point<>4)) or ((boxdir='.') or (boxdir='..')) then CheckLTB:=false;
 end;

procedure LTBAddr(dir: string; var Addr:FTNAddress);
 begin
   Addr.Zone:=StrToInt(Copy(dir,1,pos('.',dir)-1));
   Delete(dir,1,pos('.',dir));
   Addr.Net:=StrToInt(Copy(dir,1,pos('.',dir)-1));
   Delete(dir,1,pos('.',dir));
   Addr.Node:=StrToInt(Copy(dir,1,pos('.',dir)-1));
   Delete(dir,1,pos('.',dir));
   if pos('.',dir)=0 then Addr.Point:=StrToInt(dir)
   else Addr.Point:=StrToInt(Copy(dir,1,pos('.',dir)-1));
 end;

function LTBStatus(dir: string): string;
var
   count, point: integer;
 begin
   point:=0;
   for count:=1 to length(dir) do
   if dir[count]='.' then inc(point);
   Delete(dir,1,pos('.',dir));
   if point=4 then LTBStatus:='hold'
   else LTBStatus:='normal'
 end;
end.
