{
 history ( - ! :)
 0.1b9:
   -  䨪
   - ᮮ饭, 饥   㤦, p ᠫ  squish
     (㤦 㡫p, skMHLsq.pas, TSquishMessageBase.WriteMessage)
   - 뫥  RTE#217,    ᫥
     skComnTV.TMessageBaseRamStream.Flush

 sk's message handling library
 version 0.1 beta 9

 (q) by sk, 1998-99. [2:5033/27@fidonet, fidonet@mart.ru]
}
unit skMHL;

interface
uses
     skCommon;

const
{ The internal constants for work with attributes: }
 maPrivate      = $00000001;
 maCrash        = $00000002;
 maReceived     = $00000004;
 maSent         = $00000008;
 maAttach       = $00000010;
 maTransit      = $00000020;
 maOrphan       = $00000040;
 maKill         = $00000080;
 maLocal        = $00000100;
 maHold         = $00000200;
 maFRq          = $00000400;
 maRRq          = $00000800;
 maRRc          = $00001000;
 maARq          = $00002000;
 maURq          = $00004000;

{ Flags of a message base are defined by means of the following constants: }
 afNetmail      = $00000001;
 afEchomail     = $00000002;
 afLocal        = $00000004;

{ The following constants are defining the size of a temporary buffers which
  will be created while working. }
 MaxLineSize    : Longint = $4000;
 MaxMessageSize : Longint = $10000;

type
 PMessageBase = ^TMessageBase;
 TMessageBase = object
  Status: Longint;
  Opened: Boolean;
  Flags: Longint;
  CurrentMessage: Longint;
  MessageText: PMessageBaseStream;
  constructor Init;
  destructor Done; virtual;

  function Open(const Path: String): Boolean; virtual;
  function Create(const Path: String): Boolean; virtual;
  procedure Close; virtual;
  function Exists(Message: Longint): Boolean; virtual;
  function Current: Longint; virtual;
  procedure Seek(Message: Longint); virtual;
  procedure SeekNext; virtual;
  procedure SeekPrev; virtual;
  function SeekFound: Boolean; virtual;
  function GetLocation: Longint; virtual;
  procedure SetLocation(Location: Longint); virtual;
  function OpenMessage: Boolean; virtual;
  function CloseMessage: Boolean; virtual;
  function GetHighest: Longint; virtual;
  function GetCount: Longint; virtual;
  function GetFrom: String; virtual;
  function GetTo: String; virtual;
  function GetSubject: String; virtual;
  procedure GetFromAddress(var Address: TAddress); virtual;
  procedure GetToAddress(var Address: TAddress); virtual;
  procedure GetFromAndToAddress(var FromAddress, ToAddress: TAddress); virtual;
  procedure SetFrom(const S: String); virtual;
  procedure SetTo(const S: String); virtual;
  procedure SetSubject(const S: String); virtual;
  procedure SetFromAddress(var Address: TAddress; const FreshMSGID: Boolean); virtual;
  procedure SetToAddress(var Address: TAddress); virtual;
  procedure SetFromAndToAddress(var FromAddress, ToAddress: TAddress); virtual;
  procedure GetStringPChar(Line: PChar; MaxLen: Integer); virtual;
  procedure GetString(var Line: String); virtual;
  procedure PutStringPChar(Line: PChar); virtual;
  procedure PutString(const Line: String); virtual;
  function EndOfMessage: Boolean; virtual;
  procedure SetTextPos(Position: Longint); virtual;
  function GetTextPos: Longint; virtual;
  function GetTextSize: Longint; virtual;
  procedure TruncateText; virtual;
  procedure ReadText(var Buf; Count: Word); virtual;
  procedure WriteText(var Buf; Count: Word); virtual;
  function GetAttribute(Attribute: Longint): Boolean; virtual;
  procedure SetAttribute(Attribute: Longint; Enable: Boolean); virtual;
  procedure GetWrittenDateTime(var DateTime: TMessageBaseDateTime); virtual;
  procedure GetArrivedDateTime(var DateTime: TMessageBaseDateTime); virtual;
  procedure SetWrittenDateTime(var DateTime: TMessageBaseDateTime); virtual;
  procedure SetArrivedDateTime(var DateTime: TMessageBaseDateTime); virtual;
  function WriteMessage: Boolean; virtual;
  function GetKludgePChar(const Name, Destination: PChar; const MaxLen: Integer): Boolean; virtual;
  function GetKludge(const Name: String; var Destination: String): Boolean; virtual;
  procedure SetKludgePChar(const Name, Value: PChar); virtual;
  procedure SetKludge(const Name, Value: String); virtual;
  procedure DeleteKludgePChar(const Name: PChar); virtual;
  procedure DeleteKludge(const Name: String); virtual;
  function GetMessageTextStream: PMessageBaseStream; virtual;
  procedure SetFlag(const Flag: Longint; const Enable: Boolean); virtual;
  function GetFlag(const Flag: Longint): Boolean; virtual;
  procedure CheckFromAddress(const S: String; var Address: TAddress); virtual;
  procedure CheckToAddress(const S: String; var Address: TAddress); virtual;
  function CreateNewMessage: Boolean; virtual;
  function KillMessage: Boolean; virtual;
 end;

procedure GetAttributesLine(B: PMessageBase; var S: String);
procedure GetDateTimeLine(var DT: TMessageBaseDateTime; var S: String);

implementation

constructor TMessageBase.Init;
 begin
  Flags:=0;
  Status:=0;
  Opened:=False;
  MessageText:=Nil;
 end;

destructor TMessageBase.Done;
 begin
 end;

function TMessageBase.Open(const Path: String): Boolean;
 begin
  Abstract;
 end;

function TMessageBase.Create(const Path: String): Boolean;
 begin
  Abstract;
 end;

procedure TMessageBase.Close;
 begin
  Abstract;
 end;

function TMessageBase.Exists(Message: Longint): Boolean;
 begin
  Abstract;
 end;

function TMessageBase.Current: Longint;
 begin
  Abstract;
 end;

procedure TMessageBase.Seek(Message: Longint);
 begin
  CurrentMessage:=Message - 1;
  SeekNext;
 end;

procedure TMessageBase.SeekNext;
 begin
  repeat
   Inc(CurrentMessage);
   if CurrentMessage > GetHighest then
    begin
     CurrentMessage:=0;
     Break;
    end;
   if Exists(CurrentMessage) then Break;
  until False;
 end;

procedure TMessageBase.SeekPrev;
 begin
  repeat
   Dec(CurrentMessage);
   if CurrentMessage < 1 then
    begin
     CurrentMessage:=0;
     Break;
    end;
   if Exists(CurrentMessage) then Break;
  until False;
 end;

function TMessageBase.SeekFound: Boolean;
 begin
  SeekFound:=CurrentMessage <> 0;
 end;

function TMessageBase.GetLocation: Longint;
 begin
  Abstract;
 end;

procedure TMessageBase.SetLocation(Location: Longint);
 begin
  Abstract;
 end;

function TMessageBase.OpenMessage: Boolean;
 begin
  Abstract;
 end;

function TMessageBase.CloseMessage: Boolean;
 begin
  Abstract;
 end;

function TMessageBase.GetHighest: Longint;
 begin
  Abstract;
 end;

function TMessageBase.GetCount: Longint;
 begin
  Abstract;
 end;

function TMessageBase.GetFrom: String;
 begin
  Abstract;
 end;

function TMessageBase.GetTo: String;
 begin
  Abstract;
 end;

function TMessageBase.GetSubject: String;
 begin
  Abstract;
 end;

procedure TMessageBase.GetFromAddress(var Address: TAddress);
 var
  S: String;
 begin
  ClearAddress(Address);
  SetTextPos(0);
  while not EndOfMessage do
   begin
    GetString(S);
    if (S[0] = #0) or (S[1] <> #1) then Continue;
    CheckFromAddress(S, Address);
   end;
 end;

procedure TMessageBase.GetToAddress(var Address: TAddress);
 var
  S: String;
 begin
  ClearAddress(Address);
  SetTextPos(0);
  while not EndOfMessage do
   begin
    GetString(S);
    if (S[0] = #0) or (S[1] <> #1) then Continue;
    CheckToAddress(S, Address);
   end;
 end;

procedure TMessageBase.GetFromAndToAddress(var FromAddress, ToAddress: TAddress);
 var
  S: String;
 begin
  ClearAddress(FromAddress);
  ClearAddress(ToAddress);
  SetTextPos(0);
  while not EndOfMessage do
   begin
    GetString(S);
    if (S[0] = #0) or (S[1] <> #1) then Continue;
    CheckFromAddress(S, FromAddress);
    CheckToAddress(S, ToAddress);
   end;
 end;

procedure TMessageBase.SetFrom(const S: String);
 begin
  Abstract;
 end;

procedure TMessageBase.SetTo(const S: String);
 begin
  Abstract;
 end;

procedure TMessageBase.SetSubject(const S: String);
 begin
  Abstract;
 end;

procedure TMessageBase.SetFromAddress(var Address: TAddress; const FreshMSGID: Boolean);
 var
  ToAddress: TAddress;
  S: String;
 begin
  if (not FreshMSGID) and GetKludge('MSGID:', S) then
   SetKludge('MSGID:', 'MSGID: ' + AddressToStrEx(Address) + ' ' + ExtractWord(3, S, [' ']))
  else
   SetKludge('MSGID:', 'MSGID: ' + AddressToStrEx(Address) + ' ' + GenerateMSGID);
  if GetFlag(afNetmail) then
   begin
    GetToAddress(ToAddress);
    SetKludge('INTL', 'INTL ' + AddressToStrPointless(ToAddress) + ' ' + AddressToStrPointless(Address));
    if Address.Point = 0 then
     DeleteKludge('FMPT')
    else
     SetKludge('FMPT', 'FMPT ' + LongToStr(Address.Point));
   end;
 end;

procedure TMessageBase.SetToAddress(var Address: TAddress);
 var
  FromAddress: TAddress;
 begin
  if GetFlag(afNetmail) then
   begin
    GetFromAddress(FromAddress);
    SetKludge('INTL', 'INTL ' + AddressToStrPointless(Address) + ' ' + AddressToStrPointless(FromAddress));
    if Address.Point = 0 then
     DeleteKludge('TOPT')
    else
     SetKludge('TOPT', 'TOPT ' + LongToStr(Address.Point));
   end;
 end;

procedure TMessageBase.SetFromAndToAddress(var FromAddress, ToAddress: TAddress);
 begin
  SetFromAddress(FromAddress, False);
  SetToAddress(ToAddress);
 end;

procedure TMessageBase.GetStringPChar(Line: PChar; MaxLen: Integer);
 const
  BufferSize = 1024;
 var
  Buffer: Array[1..BufferSize + 1] Of Char;
  SavePos, Pos, Size, StreamSize, K, LS: Longint;
  CurLen: Integer;
  LineSize: Longint;
 procedure PutBuffer;
  begin
   {--- originally by sk: ---
    while LineSize + Size > MaxLen do
     Dec(Size);
   }
   {--- by S0t // S0tSoft, 345:817/28: ---}
   if LineSize + Size > MaxLen then
    Size:=MaxLen - LineSize;

   if Size < 0 then Exit;
   Buffer[Size + 1]:=#0;
   ConcatASCIIZ(Line, @Buffer);
   Inc(LineSize, Size);
  end;
 begin
  Pos:=0;
  CurLen:=0;
  ToASCIIZ('', Line);
  LineSize:=0;
  StreamSize:=MessageText^.GetSize;
  SavePos:=MessageText^.GetPos;
  repeat
   Size:=StreamSize - SavePos;
   if Size <= 0 then Exit;
   if Size > BufferSize then Size:=BufferSize;
   MessageText^.Read(Buffer, Size);
   for K:=1 to Size do
    if Buffer[K] in [#13, #0] then
     begin
      Buffer[K]:=#0;

      {mab}
      if (K < Size) and (Buffer[K + 1] = #10) then
       Inc(K);
      {/mab}

      PutBuffer;
      MessageText^.Seek(SavePos + K);
      Exit;
     end;
   Buffer[Size + 1]:=#0;
   Inc(SavePos, Size);
   PutBuffer;
  until False;
 end;

procedure TMessageBase.GetString(var Line: String);
 var
  L: PChar;
 const
  StringLen = 255;
 begin
  GetMem(L, StringLen + 1);
  GetStringPChar(L, StringLen);
  Line:=FromASCIIZ(L);
  FreeMem(L, StringLen + 1);
 end;

procedure TMessageBase.PutStringPChar(Line: PChar);
 const
  B: System.Byte = 13;
 begin
  MessageText^.Write(Line^, LenASCIIZ(Line));
  MessageText^.Write(B, SizeOf(B));
 end;


procedure TMessageBase.PutString(const Line: String);
 var
  L: PChar;
 begin
  GetMem(L, Length(Line) + 1);
  ToASCIIZ(Line, L);
  PutStringPChar(L);
  FreeMem(L, Length(Line) + 1);
 end;

function TMessageBase.EndOfMessage: Boolean;
 begin
  EndOfMessage:=MessageText^.GetSize = MessageText^.GetPos;
 end;

procedure TMessageBase.SetTextPos(Position: Longint);
 begin
  MessageText^.Seek(Position);
 end;

function TMessageBase.GetTextPos: Longint;
 begin
  GetTextPos:=MessageText^.GetPos;
 end;

function TMessageBase.GetTextSize: Longint;
 begin
  GetTextSize:=MessageText^.GetSize;
 end;

procedure TMessageBase.TruncateText;
 begin
  MessageText^.Truncate;
 end;

procedure TMessageBase.ReadText(var Buf; Count: Word);
 begin
  MessageText^.Read(Buf, Count);
 end;

procedure TMessageBase.WriteText(var Buf; Count: Word);
 begin
  MessageText^.Write(Buf, Count);
 end;

function TMessageBase.GetAttribute(Attribute: Longint): Boolean;
 begin
  Abstract;
 end;

procedure TMessageBase.SetAttribute(Attribute: Longint; Enable: Boolean);
 begin
  Abstract;
 end;

procedure TMessageBase.GetWrittenDateTime(var DateTime: TMessageBaseDateTime);
 begin
  Abstract;
 end;

procedure TMessageBase.GetArrivedDateTime(var DateTime: TMessageBaseDateTime);
 begin
  Abstract;
 end;

procedure TMessageBase.SetWrittenDateTime(var DateTime: TMessageBaseDateTime);
 begin
  Abstract;
 end;

procedure TMessageBase.SetArrivedDateTime(var DateTime: TMessageBaseDateTime);
 begin
  Abstract;
 end;

function TMessageBase.WriteMessage: Boolean;
 begin
  Abstract;
 end;

function TMessageBase.GetKludgePChar(const Name, Destination: PChar; const MaxLen: Integer): Boolean;
 var
  K: Integer;
  L: Integer;
  M: Integer;
  F: Boolean;
 begin
  GetKludgePChar:=False;
  M:=LenASCIIZ(Name);
  SetTextPos(0);
  Destination[0]:=#0;
  while not EndOfMessage do
   begin
    GetStringPChar(Destination, MaxLen);
    L:=LenASCIIZ(Destination);
    if L > M then
     L:=M
    else
     Continue;
    F:=True;
    for K:=0 to M - 1 do
     if Destination[K] <> Name[K] then
      begin
       F:=False;
       Break;
      end;
    if F then
     begin
      GetKludgePChar:=True;
      Exit;
     end;
   end;
 end;

function TMessageBase.GetKludge(const Name: String; var Destination: String): Boolean;
 const
  DestinationSize = SizeOf(String);
 var
  AName, ADestination: PChar;
 begin
  GetMem(ADestination, DestinationSize);
  GetMem(AName, Length(Name) + 1);
  ToASCIIZ(Name, AName);
  GetKludge:=GetKludgePChar(AName, ADestination, DestinationSize - 1);
  Destination:=FromASCIIZ(ADestination);
  FreeMem(AName, Length(Name) + 1);
  FreeMem(ADestination, DestinationSize);
 end;

procedure TMessageBase.SetKludgePChar(const Name, Value: PChar);
 var
  K: Integer;
  L: Integer;
  M: Integer;
  F, D: Boolean;
  Line: PChar;
  S: PMessageBaseStream;
 const
  C: System.Byte = 13;
 begin
  S:=CreateMessageBaseMemoryStream(MaxMessageSize);
  GetMem(Line, MaxLineSize);
  M:=LenASCIIZ(Name);
  D:=False;
  SetTextPos(0);
  while not EndOfMessage do
   begin
    GetStringPChar(Line, MaxLineSize - 1);
    L:=LenASCIIZ(Line);
    if L >= M then
     begin
      L:=M;
      F:=True;
      for K:=0 to M - 1 do
       if Line[K] <> Name[K] then
        begin
         F:=False;
         Break;
        end;
     end
    else
     F:=False;
    if F then
     begin
      S^.Write(Value^, LenASCIIZ(Value));
      S^.Write(C, SizeOf(C));
      D:=True;
     end
    else
     begin
      S^.Write(Line^, LenASCIIZ(Line));
      S^.Write(C, SizeOf(C));
     end;
   end;
  if not D then
   begin
    S^.Seek(0);
    S^.Truncate;
    S^.Write(Value^, LenASCIIZ(Value));
    S^.Write(C, SizeOf(C));
    GetMessageTextStream^.Seek(0);
    S^.CopyFrom(GetMessageTextStream^, GetMessageTextStream^.GetSize);
   end;
  S^.Seek(0);
  GetMessageTextStream^.Seek(0);
  GetMessageTextStream^.Truncate;
  GetMessageTextStream^.CopyFrom(S^, S^.GetSize);
  GetMessageTextStream^.Truncate;
  FreeMem(Line, MaxLineSize);
  Dispose(S, Done);
 end;

procedure TMessageBase.SetKludge(const Name, Value: String);
 var
  AName, AValue: PChar;
 begin
  GetMem(AName, Length(Name) + 1);
  GetMem(AValue, Length(Value) + 1);
  ToASCIIZ(Name, AName);
  ToASCIIZ(Value, AValue);
  SetKludgePChar(AName, AValue);
  FreeMem(AValue, Length(Value) + 1);
  FreeMem(AName, Length(Name) + 1);
 end;

procedure TMessageBase.DeleteKludgePChar(const Name: PChar);
 var
  K: Integer;
  L: Integer;
  M: Integer;
  F, D: Boolean;
  Line: PChar;
  S: PMessageBaseStream;
 const
  C: System.Byte = 13;
 begin
  S:=CreateMessageBaseMemoryStream(MaxMessageSize);
  GetMem(Line, MaxLineSize);
  M:=LenASCIIZ(Name);
  SetTextPos(0);
  while not EndOfMessage do
   begin
    GetStringPChar(Line, MaxLineSize - 1);
    L:=LenASCIIZ(Line);
    if L >= M then
     begin
      L:=M;
      F:=True;
      for K:=0 to M - 1 do
       if Line[K] <> Name[K] then
        begin
         F:=False;
         Break;
        end;
     end
    else
     F:=False;
    if not F then
     begin
      S^.Write(Line^, LenASCIIZ(Line));
      S^.Write(C, SizeOf(C));
     end;
   end;
  S^.Seek(0);
  GetMessageTextStream^.Seek(0);
  GetMessageTextStream^.Truncate;
  GetMessageTextStream^.CopyFrom(S^, S^.GetSize);
  GetMessageTextStream^.Truncate;
  FreeMem(Line, MaxLineSize);
  Dispose(S, Done);
 end;

procedure TMessageBase.DeleteKludge(const Name: String);
 var
  AName: PChar;
 begin
  GetMem(AName, Length(Name) + 1);
  ToASCIIZ(Name, AName);
  DeleteKludgePChar(AName);
  FreeMem(AName, Length(Name) + 1);
 end;

function TMessageBase.GetMessageTextStream: PMessageBaseStream;
 begin
  GetMessageTextStream:=MessageText;
 end;

procedure TMessageBase.SetFlag(const Flag: Longint; const Enable: Boolean);
 begin
  if Enable then
   Flags:=Flags or Flag
  else
   Flags:=Flags and not Flag;
 end;

function TMessageBase.GetFlag(const Flag: Longint): Boolean;
 begin
  GetFlag:=Flags and Flag = Flag;
 end;

procedure TMessageBase.CheckFromAddress(const S: String; var Address: TAddress);
 begin
  if Copy(S, 1, 7) = 'MSGID:' then
   StrToAddress(ExtractWord(2, S, [' ']), Address);
  if Copy(S, 1, 5) = 'INTL' then
   StrToAddress(ExtractWord(3, S, [' ']), Address);
  if Copy(S, 1, 5) = 'FMPT' then
   StrToInteger(ExtractWord(2, S, [' ']), Address.Point);
 end;

procedure TMessageBase.CheckToAddress(const S: String; var Address: TAddress);
 begin
  if Copy(S, 1, 5) = 'INTL' then
   StrToAddress(ExtractWord(2, S, [' ']), Address);
  if Copy(S, 1, 5) = 'TOPT' then
   StrToInteger(ExtractWord(2, S, [' ']), Address.Point);
 end;

function TMessageBase.CreateNewMessage: Boolean;
 begin
  Abstract;
 end;

function TMessageBase.KillMessage: Boolean;
 begin
  Abstract;
 end;

{* Stuff *}

procedure GetAttributesLine(B: PMessageBase; var S: String);
 begin
  S:='';
  if B^.GetAttribute(maPrivate) then S:=S + 'Pvt ';
  if B^.GetAttribute(maCrash) then S:=S + 'Cra ';
  if B^.GetAttribute(maReceived) then S:=S + 'Rcv ';
  if B^.GetAttribute(maSent) then S:=S + 'Snt ';
  if B^.GetAttribute(maAttach) then S:=S + 'Att ';
  if B^.GetAttribute(maTransit) then S:=S + 'Trs ';
  if B^.GetAttribute(maOrphan) then S:=S + 'Orp ';
  if B^.GetAttribute(maKill) then S:=S + 'K/s ';
  if B^.GetAttribute(maLocal) then S:=S + 'Loc ';
  if B^.GetAttribute(maHold) then S:=S + 'Hld ';
  if B^.GetAttribute(maFRq) then S:=S + 'FRq ';
  if B^.GetAttribute(maRRq) then S:=S + 'RRq ';
  if B^.GetAttribute(maRRc) then S:=S + 'RRc ';
  if B^.GetAttribute(maARq) then S:=S + 'ARq ';
  if B^.GetAttribute(maURq) then S:=S + 'URq ';
  if S[0] <> #0 then Dec(S[0]);
 end;

procedure GetDateTimeLine(var DT: TMessageBaseDateTime; var S: String);
 function LeadingZero(Number, Count: Longint): String;
  var
   S: String;
  begin
   S:=LongToStr(Number);
   while Length(S) < Count do
    S:='0' + S;
   LeadingZero:=S;
  end;
 begin
  S:=LeadingZero(DT.Year, 4) + '/' +
     LeadingZero(DT.Month, 2) + '/' +
     LeadingZero(DT.Day, 2) + ' ' +
     LeadingZero(DT.Hour, 2) + ':' +
     LeadingZero(DT.Min, 2) + ':' +
     LeadingZero(DT.Sec, 2) + '.' +
     LeadingZero(DT.Sec100, 2);
 end;

end.
