uses
     Crt,
     skMHL, skCommon, skComnTV, skOpen;

const
 Version = '0.2';
 Attributes: Array[1..15] Of Longint = (maPrivate, maCrash, maReceived, maSent,
  maAttach, maTransit, maOrphan, maKill, maLocal, maHold, maFRq, maRRq,
  maRRc, maARq, maURq);

var
 Source, Destination: PMessageBase;
 Memory: Longint;
 FromAddress, ToAddress: TAddress;
 DateTime: TMessageBaseDateTime;
 K, Count: Longint;
 SourcePath, DestinationPath: String;
begin
 Memory:=MemAvail;
 ClrScr;
 WriteLn('sk''s Message Base Converter, v', Version, ' (c) by sk // [rAN] [2:5033/27], 1998-99.');
 WriteLn;
 if ParamCount < 2 then
  begin
   WriteLn('Usage: skMSGcvt source destination');
   WriteLn('Example: skMSGcvt FF:\Fido\Netmail JF:\Fido\Areas\Netmail');
   WriteLn('         skMSGcvt SF:\Fido\Areas\ramp3 FF:\Fido\Areas\Ramp3.msg\');
   Halt;
  end;

 SourcePath:=ParamStr(1);
 DestinationPath:=ParamStr(2);

 WriteLn('Source: "', SourcePath, '"');
 WriteLn('Destination: "', DestinationPath, '"');
 WriteLn;

 InstallMHLCommon;

 Source:=Nil;
 Destination:=Nil;
 repeat
  if not OpenMessageBase(Source, SourcePath) then
   begin
    WriteLn('Cannot open source messagebase, rc=#', OpenStatus);
    Break;
   end;
  WriteLn('Source messagebase opened.');
  if not OpenOrCreateMessageBase(Destination, DestinationPath) then
   begin
    WriteLn('Cannot open destination messagebase, rc=#', OpenStatus);
    Break;
   end;
  WriteLn('Destination messagebase opened.');
  WriteLn;
  WriteLn('Source messagebase - total ', Source^.GetCount, ', high ', Source^.GetHighest, '.');
  WriteLn('Destination messagebase - total ', Destination^.GetCount, ', high ', Destination^.GetHighest, '.');
  WriteLn;

  Count:=0;

  Source^.Seek(1);
  while Source^.SeekFound do
   begin
    if Keypressed then
     begin
      Write(#13, 'Terminated.');
      ClrEol;
      Break;
     end;
    Write(#13, 'Copying message #', Source^.Current, ': ');
    ClrEol;

    if not Source^.OpenMessage then
     begin
      Write(#13, 'Cannot open message #', Source^.Current, ': ', Source^.Status);
      ClrEol;
      WriteLn;
     end
    else
     begin
      if not Destination^.CreateNewMessage then
       begin
        Write(#13, 'Cannot create message: ', Destination^.Status);
        ClrEol;
        WriteLn;
       end
      else
       begin
        Source^.GetMessageTextStream^.Seek(0);
        with Destination^.GetMessageTextStream^ do
         begin
          Seek(0);
          CopyFrom(Source^.GetMessageTextStream^, Source^.GetMessageTextStream^.GetSize);
          Truncate;
          Flush;
         end;
        Write('t');

        Destination^.SetFrom(Source^.GetFrom);
        Destination^.SetTo(Source^.GetTo);
        Destination^.SetSubject(Source^.GetSubject);
        Source^.GetFromAndToAddress(FromAddress, ToAddress);
        Destination^.SetFromAndToAddress(FromAddress, ToAddress);

        Source^.GetWrittenDateTime(DateTime);
        Destination^.SetWrittenDateTime(DateTime);
        Source^.GetArrivedDateTime(DateTime);
        Destination^.SetArrivedDateTime(DateTime);

        Write('h');

        for K:=Low(Attributes) to High(Attributes) do
         Destination^.SetAttribute(Attributes[K], Source^.GetAttribute(Attributes[K]));

        Write('a');

        if not Destination^.WriteMessage then
         begin
          Write(#13, 'Cannot write message: ', Destination^.Status);
          ClrEol;
          WriteLn;
         end
        else
         begin
          Inc(Count);
          Write('w');
         end;
        Destination^.CloseMessage;
       end;
      Source^.CloseMessage;
     end;

    Source^.SeekNext;
   end;

  WriteLn;
 until True;

 WriteLn;
 WriteLn('Copied ', Count, ' message(s).');
 WriteLn;

 if Source <> Nil then
  begin
   CloseMessageBase(Source);
   WriteLn('Source messagebase closed.');
  end;
 if Destination <> Nil then
  begin
   CloseMessageBase(Destination);
   WriteLn('Destination messagebase closed.');
  end;
 WriteLn;
 WriteLn('Memory leak is ', Memory - MemAvail, ' bytes.');
end.