{

TheTapir! Outbound Analyser

Copyright (c) 1999, Beta Technologies

Copyright (c) 1999, Vladimir Zaytcev, 2:5015/116@fidonet

}

{os type directives definishion}
{$IFDEF MSDOS}{$DEFINE DOS}{$ENDIF}
{$IFDEF DPMI}{$DEFINE DOS}{$ENDIF}
{$IFDEF D32}{$DEFINE DOS}{$ENDIF}
{$IFDEF WIN32}{$DEFINE W32}{$ENDIF}
{$IFDEF VIRTUALPASCAL}{$DEFINE VP}{$ENDIF}

program TheTapir_Outbound_Analyser;

uses Dos, Objects, Crt, BConfig, BLog, BUtils, BFTNUtil, BMacro, TapirSum
     ,skMHL, skOpen, skCommon, skComnTv;

const
    AvailParams : Array [1..17] of string[20] = (
                  'Address',
                  'UserName',
                  'BBDir',
                  'TBDir',
                  'Outbound',
                  'Output',
                  'Subject',
                  'FromAddr',
                  'FromName',
                  'ToAddr',
                  'ToName',
                  'Tearline',
                  'Origin',
                  'Mode',
                  'SortBy',
                  'UseTics',
                  'Link');

var
    ConfigName, Output, Bundle, BSOname, BSOpath, SortBy, OutType: String;
    TapirConfig: TBConfig; TapirOut : TBLog;
    SR, SRP, SROB, SRB : SearchRec;
    CTime, FTime, MTime, GlobalSize: longint;
    Statistic, StatOut: PCollection;
    LinkRec, LinkRec1, LinkRec2 : PTapirStatRec;
    Str: PStr;
    Link1, Link2: TTapirStatRec;
    Count, StrCount, LinkCount, AddrCount, Line: Integer;
    BoxAddress, Address, SysopAddr: FTNAddress;
    AlreadySorted, Overwrite, ExitFlag, SomeWritten: boolean;
    lo: text; bfile: file of byte;
    Base: PMessageBase;
    FromAddr, ToAddr: TAddress;
    T: TMessageBaseDateTime;

procedure ShowHeader;
 begin
   TextColor(10); Write( ' TheTapir! Outbound Analyser v0.11        ');
   TextColor(15); Writeln('Copyright (c) 1999, Beta Technologies');
   TextColor(12);  WriteLn('');
 end;

function FmtStr(Rec : TTapirStatRec):String;
var
   ads, flv, mc, md, fc, fd, ms, fs:string;
   count: integer;
   Res: String;

 begin
  if LowerCase(Rec.flavour)='immediate' then flv:='imm' else
  if LowerCase(Rec.flavour)='crash'     then flv:='cra' else
  if LowerCase(Rec.flavour)='direct'    then flv:='dir' else
  if LowerCase(Rec.flavour)='normal'    then flv:='nrm' else
  if LowerCase(Rec.flavour)='hold'      then flv:='hld' else
  if LowerCase(Rec.flavour)='online'    then flv:='onl' else
  if LowerCase(Rec.flavour)='report'    then flv:='rep' else
  if LowerCase(Rec.flavour)='request'   then flv:='req' else
  if LowerCase(Rec.flavour)='busy'      then flv:='bsy' else
  if LowerCase(Rec.flavour)='status'    then flv:='sts' else flv:='unn';
  ads:=Copy(Addr2Str(Rec.Address),1,16);
  if Length(ads)<16 then
    for count:=1 to 16-Length(ads) do ads := ads + #32;
  Res :=#179+#32+ads+#32+#179+#32+flv+#32++#179+#32;
  if Rec.BundlesCount<>0 then
    begin
      mc:=IntToStr(Rec.BundlesCount);
      if Length(mc)<3 then
      for count:=1 to 3-Length(mc) do mc := mc + #32;
    end
  else mc := #45+#32+#32;
  Res :=Res+mc+#32+#179+#32;

  if Rec.BundlesSize<>0 then
    begin
      if (Rec.BundlesSize div 1024)=0 then ms:='1' else
      ms:=IntToStr(Rec.BundlesSize div 1024);
      if Length(ms)<6 then
        for count:=1 to 6-Length(ms) do ms := ms + #32;
    end
  else ms :=#45+#32+#32+#32+#32+#32;

  if Rec.BundlesCount<>0 then
  md:=DateFmt(Rec.OldiestBundle,'/',true,true)
  else md :=#45+#32+#32+#32+#32+#32+#32+#32;

  Res :=Res+ms+#32+#179+#32+md+#32+#179+#32;

  if Rec.FilesCount<>0 then
    begin
      fc:=IntToStr(Rec.FilesCount);
      if Length(fc)<3 then
      for count:=1 to 3-Length(fc) do fc := fc + #32;
    end
  else fc := #45+#32+#32;
  Res :=Res+fc+#32+#179+#32;

  if Rec.FilesSize<>0 then
    begin
      if (Rec.FilesSize div 1024)=0 then fs:='1' else
      fs:=IntToStr(Rec.FilesSize div 1024);
      if Length(fs)<6 then
      for count:=1 to 6-Length(fs) do fs := fs + #32;
    end
  else fs :=#45+#32+#32+#32+#32+#32;

  if Rec.FilesCount<>0 then
  fd:=DateFmt(Rec.OldiestFile,'/',true,true)
  else fd :=#45+#32+#32+#32+#32+#32+#32+#32;

  Res :=Res+fs+#32+#179+#32+fd+#32+#179;

  FmtStr:=Res;

end;

procedure Error(const S: String);
 begin
   WriteLn(S);
   Halt(255);
 end;

begin

 if not KeyExists('/?') then
 if not KeyExists('/about') then
   begin
     ClrScr; ShowHeader;
     TextColor(14);
     InstallMHLcommon;

     if FindKey('/c:')<>0
       then ConfigName:=GetKeyValue(FindKey('/c:'))
       else ConfigName:='tapir.ctl';

     if fileexists(ConfigName) then TapirConfig.Create(ConfigName)
     else  Error(' Configuration file '+LowerCase(ConfigName)+' not found');

     if FindKey('/out:')<>0 then
       begin
         Output:=GetKeyValue(FindKey('/out:'));
         OutType:='File';
       end
     else
       begin
         Output:=TapirConfig.ReadValue('Output','',Line);
         If Output[1]='!' then OutType:='Jam' else
         If Output[1]='$' then OutType:='Squish' else
         If Output[1]='#' then OutType:='Msg' else
         If Output[1]='~' then OutType:='File' else
         Error('Error reading "Output" type in '+LowerCase(ExtractFileName(ConfigName)));
         Output:=Copy(Output,2,Length(Output));
       end;

     {checking config}
     Write('Checking config - ');
     for Count:=1 to TapirConfig.RecCount-1 do
        begin
          ExitFlag := True;
          for StrCount:=1 to 17 do
          if LowerCase(TapirConfig.ParamName(Count, Line))=LowerCase(AvailParams[StrCount]) then ExitFlag := false;
          if ExitFlag then
            begin
              WriteLn('Unknown parameter "',TapirConfig.ParamName(Count, Line),'" at line ',Line,' in '
              ,LowerCase(ExtractFileName(ConfigName)));
              TapirConfig.Free;
              Exit;
            end;
        end;

     if TapirConfig.ValueCount('Link')=0 then
       begin
         WriteLn('No links defined in ',LowerCase(ExtractFileName(ConfigName)));
         TapirConfig.Free;
         Exit;
       end;

     if TapirConfig.ValueCount('Outbound')=0 then
       begin
         WriteLn('Outbound not defined in ',LowerCase(ExtractFileName(ConfigName)));
         TapirConfig.Free;
         Exit;
       end;

     if TapirConfig.ValueCount('address')=0 then
       begin
         WriteLn('Sysop''s address not defined in ',LowerCase(ExtractFileName(ConfigName)));
         TapirConfig.Free;
         Exit;
       end;

     SortBy:=UpperCase(TapirConfig.ReadValue('UseTics','No',Line));
     if ((SortBy<>'NO') and (SortBy<>'YES') and (SortBy<>'TRUE') and (SortBy<>'FALSE')) then
       begin
         WriteLn('Invalid value ',SortBy,'" for "UseTics" parameter at line ',line,' in '
         ,LowerCase(ExtractFileName(ConfigName)));
         TapirConfig.Free;
         Exit;
       end;

     SortBy:=UpperCase(TapirConfig.ReadValue('Mode','Overwrite',Line));
     if ((SortBy<>'OVERWRITE') and (SortBy<>'ADD')) then
       begin
         WriteLn('Invalid value "',SortBy,'" for "Mode" parameter at line ',line,' in '
         ,LowerCase(ExtractFileName(ConfigName)));
         TapirConfig.Free;
         Exit;
       end;

     SortBy:=UpperCase(TapirConfig.ReadValue('SortBy','S',Line));
     if ((SortBy<>'S') and (SortBy<>'VS') and (SortBy<>'A') and (SortBy<>'VA')) then
       begin
         WriteLn('Invalid value "',SortBy,'" for "SortBy" parameter at line ',line,' in '
         ,LowerCase(ExtractFileName(ConfigName)));
         TapirConfig.Free;
         Exit;
       end;

     WriteLn('Done.');

     Statistic:=New(PCollection, Init($10,$10));
     StatOut:=New(PCollection, Init($10,$10));

     AddMacro('Sysop',TapirConfig.ReadValue('UserName','Sysop', Line));
     Str2Addr(TapirConfig.ReadValue('Address','0:0/0.0', Line),SysopAddr);
     AddMacro('4daddr',Addr2Str(SysopAddr));
     AddMacro('5daddr',Addr2Str5d(SysopAddr));
     AddMacro('date',TakeDateFmt('/',true,true));
     AddMacro('shortdate',TakeDateFmt('/',false,true));
     AddMacro('time',TakeTimeFmt(':',true));
     AddMacro('shorttime',TakeTimeFmt(':',false));
     AddMacro('longpid','TheTapir! Outbound Analyser');
     {$IFDEF DOS}AddMacro('pid','TheTapir!/DOS');{$ENDIF}
     {$IFDEF DPMI}AddMacro('pid','TheTapir!/DPMI');{$ENDIF}
     {$IFDEF DPMI32}AddMacro('pid','TheTapir!/DPMI');{$ENDIF}
     {$IFDEF W32}AddMacro('pid','TheTapir!/W32');{$ENDIF}
     {$IFDEF OS2}AddMacro('pid','TheTapir!/OS2');{$ENDIF}
     AddMacro('version','0.11');
     AddMacro('dow',DayOfWeek);

     {᪠㥬  ⡠㭤}
     Write('Scanning Outbound - ');
     bsoname:=TapirConfig.ReadValue('outbound','outbound', Line);
     if bsoname[length(bsoname)]='\' then bsoname:=Copy(bsoname,1,length(bsoname)-1);
     bsoname:=Copy(bsoname, LastPos('\',bsoname)+1, Length(bsoname));
     If LowerCase(SysopAddr.Domain)<>'fidonet' then bsoname:= SysopAddr.Domain;

     bsopath:=TapirConfig.ReadValue('outbound','outbound', Line);
     if bsopath[length(bsopath)]='\' then bsopath:=Copy(bsopath,1,length(bsopath)-1);
     bsopath:=Copy(bsopath, 1, LastPos('\',bsopath));

     FindFirst(AddBackSlash(bsopath)+bsoname+'.*', Directory, SROB);
       while DosError = 0 do
         begin
           if ( (srob.name<>'.') and (srob.name<>'..') ) then
           if srob.attr=((srob.attr) and (not archive)) then
           if LastPos('.',SROB.Name)<>0
           then Address.Zone := HexToInt(Copy(SROB.Name,LastPos('.',SROB.Name)+1,3))
           else Address.Zone := SysopAddr.Zone;

           {nodes}
           {mail}
           FindFirst(AddBackSlash(bsopath)+AddBackSlash(srob.name)+'*.?ut', Archive, SR);
           while DosError = 0 do
             begin
               Address.Point:=0;
               Address.Net := HexToInt(Copy(SR.Name,1,4));
               Address.Node := HexToInt(Copy(SR.Name,5,4));
               Address.Domain := SysopAddr.Domain;
               Statistic^.Insert(New(PTapirStatRec,Init(Address)));
               LinkRec:=Statistic^.At(Statistic^.Count-1);
               LinkRec^.Flavour:=UtFlavour(SR.Name);
               Inc(LinkRec^.BundlesCount);
               Assign(bfile,AddBackSlash(bsopath)+AddBackSlash(srob.name)+SR.Name);
               Reset(bfile);
               PackTime(CurrDateTime^, CTime);
               GetFTime(bfile,Ftime);
               if Ftime<CTime then CTime:=Ftime;
               Inc(LinkRec^.BundlesCount);
               LinkRec^.BundlesSize:=LinkRec^.BundlesSize+FileSize(bfile);
               Close(bfile);
               UnPackTime(CTime,LinkRec^.OldiestBundle);
               FindNext(SR);
             end;

           {bundles/files}
           FindFirst(AddBackSlash(bsopath)+AddBackSlash(srob.name)+'*.?lo', Archive, SR);
           while DosError = 0 do
             begin
               Address.Point:=0;
               Address.Net := HexToInt(Copy(SR.Name,1,4));
               Address.Node := HexToInt(Copy(SR.Name,5,4));
               Address.Domain := SysopAddr.Domain;

               if Statistic^.Count=0 then
                 begin
                   Statistic^.Insert(New(PTapirStatRec,Init(Address)));
                   LinkRec:=Statistic^.At(Statistic^.Count-1);
                 end
               else
                 for count:=0 to Statistic^.Count-1 do
                   begin
                     LinkRec:=Statistic^.At(Count);
                     If CompareAddr(LinkRec^.Address,Address) then Break;
                   end;
               if not CompareAddr(LinkRec^.Address,Address) then
                 begin
                   Statistic^.Insert(New(PTapirStatRec,Init(Address)));
                   LinkRec:=Statistic^.At(Statistic^.Count-1);
                 end;

               if LinkRec^.Flavour='' then LinkRec^.Flavour:=LoFlavour(SR.Name);

               Assign(lo,AddBackSlash(bsopath)+AddBackSlash(srob.name)+SR.Name);
               Reset(lo); Reset(lo);
               while not eof (lo) do
                 begin
                   ReadLn(lo,bundle);
                   if ((bundle[1]='#') or (bundle[1]='^')) then
                   bundle:=Copy(bundle,2,length(bundle));

                   if not (TapirConfig.ReadBoolean('UseTics',false, Line)) then
                   if LowerCase(Copy(bundle,LastPos('.',Bundle)+1,3))='tic'
                   then bundle:='';

                   if fileexists(bundle) then
                   if (IsBundle(bundle) or IsPkt(bundle) or IsUt(bundle)) then
                     begin
                       PackTime(LinkRec^.OldiestBundle, MTime);
                       Inc(LinkRec^.BundlesCount);
                       Assign(bfile,bundle);
                       Reset(bfile);
                       GetFTime(bfile,Ftime);
                       if Ftime<MTime then MTime:=Ftime;
                       LinkRec^.BundlesSize:=LinkRec^.BundlesSize+FileSize(bfile);
                       UnPackTime(MTime,LinkRec^.OldiestBundle);
                       Close(bfile);
                     end
                   else
                     begin
                       PackTime(LinkRec^.OldiestFile, CTime);
                       Inc(LinkRec^.FilesCount);
                       Assign(bfile,bundle);
                       Reset(bfile);
                       GetFTime(bfile,Ftime);
                       if Ftime<CTime then CTime:=Ftime;
                       LinkRec^.FilesSize:=LinkRec^.FilesSize+FileSize(bfile);
                       UnPackTime(CTime,LinkRec^.OldiestFile);
                       Close(bfile);
                     end;
                 end;
               Close(lo);
               FindNext(SR);
             end;

           {points}
           FindFirst(AddBackSlash(bsopath)+AddBackSlash(srob.name)+'*.*', Directory, SR);
           while DosError = 0 do
             begin
               {mail}
               if ( (sr.name<>'.') and (sr.name<>'..') ) then
               if sr.attr=((sr.attr) and (not archive)) then
                 begin
                   FindFirst(AddBackSlash(bsopath)+AddBackSlash(srob.name)+AddBackSlash(SR.Name)+'*.?ut', Archive, SRP);
                     while DosError = 0 do
                       begin
                         Address.Net  := HexToInt(Copy(Copy(SR.Name,1,lastpos('.',SR.Name)-1),1,4));
                         Address.Node := HexToInt(Copy(Copy(SR.Name,1,lastpos('.',SR.Name)-1),5,4));
                         Address.Point:= HexToInt(Copy(SRP.Name,1,lastpos('.',SRP.Name)-1));
                         Address.Domain := SysopAddr.Domain;
                         Statistic^.Insert(New(PTapirStatRec,Init(Address)));
                         LinkRec:=Statistic^.At(Statistic^.Count-1);
                         LinkRec^.Flavour:=UtFlavour(SRP.Name);
                         Inc(LinkRec^.BundlesCount);
                         Assign(bfile,AddBackSlash(bsopath)+AddBackSlash(srob.name)+AddBackSlash(SR.Name)+SRP.Name);
                         Reset(bfile);
                         PackTime(CurrDateTime^, CTime);
                         GetFTime(bfile,Ftime);
                         if Ftime<CTime then CTime:=Ftime;
                         Inc(LinkRec^.BundlesCount);
                         LinkRec^.BundlesSize:=LinkRec^.BundlesSize+FileSize(bfile);
                         Close(bfile);
                         UnPackTime(CTime,LinkRec^.OldiestBundle);
                         FindNext(SRP);
                       end;

                   FindFirst(AddBackSlash(bsopath)+AddBackSlash(srob.name)+AddBackSlash(SR.Name)+'*.?lo', Archive, SRP);
                     while DosError = 0 do
                       begin
                         Address.Net  := HexToInt(Copy(Copy(SR.Name,1,lastpos('.',SR.Name)-1),1,4));
                         Address.Node := HexToInt(Copy(Copy(SR.Name,1,lastpos('.',SR.Name)-1),5,4));
                         Address.Point:= HexToInt(Copy(SRP.Name,1,lastpos('.',SRP.Name)-1));
                         Address.Domain := SysopAddr.Domain;

                         if Statistic^.Count=0 then
                           begin
                             Statistic^.Insert(New(PTapirStatRec,Init(Address)));
                             LinkRec:=Statistic^.At(Statistic^.Count-1);
                           end
                         else
                           for count:=0 to Statistic^.Count-1 do
                             begin
                               LinkRec:=Statistic^.At(Count);
                               If CompareAddr(LinkRec^.Address,Address) then Break;
                             end;
                         if not CompareAddr(LinkRec^.Address,Address) then
                           begin
                             Statistic^.Insert(New(PTapirStatRec,Init(Address)));
                             LinkRec:=Statistic^.At(Statistic^.Count-1);
                           end;

                         if LinkRec^.Flavour='' then LinkRec^.Flavour:=LoFlavour(SRP.Name);

                         Assign(lo,AddBackSlash(bsopath)+AddBackSlash(srob.name)+AddBackSlash(SR.Name)+SRP.Name);
                         Reset(lo);
                         while not eof (lo) do
                           begin
                             ReadLn(lo,bundle);
                             if ((bundle[1]='#') or (bundle[1]='^')) then
                             bundle:=Copy(bundle,2,length(bundle));

                             if not (TapirConfig.ReadBoolean('UseTics',false, Line)) then
                             if LowerCase(Copy(bundle,LastPos('.',Bundle)+1,3))='tic'
                             then bundle:='';

                             if fileexists(bundle) then
                             if (IsBundle(bundle) or IsPkt(bundle) or IsUt(bundle)) then
                               begin
                                 PackTime(LinkRec^.OldiestBundle, MTime);
                                 Inc(LinkRec^.BundlesCount);
                                 Assign(bfile,bundle);
                                 Reset(bfile);
                                 GetFTime(bfile,Ftime);
                                 if Ftime<MTime then MTime:=Ftime;
                                 LinkRec^.BundlesSize:=LinkRec^.BundlesSize+FileSize(bfile);
                                 UnPackTime(MTime,LinkRec^.OldiestBundle);
                                 Close(bfile);
                               end
                             else
                               begin
                                 PackTime(LinkRec^.OldiestFile, CTime);
                                 Inc(LinkRec^.FilesCount);
                                 Assign(bfile,bundle);
                                 Reset(bfile);
                                 GetFTime(bfile,Ftime);
                                 if Ftime<CTime then CTime:=Ftime;
                                 LinkRec^.FilesSize:=LinkRec^.FilesSize+FileSize(bfile);
                                 UnPackTime(CTime,LinkRec^.OldiestFile);
                                 Close(bfile);
                               end;
                           end;
                         Close(lo);
                         FindNext(SRP);
                       end;
                   end;
                 FindNext(SR);
               end;
           FindNext(SROB);
         end;
     WriteLn('Done.');

     {ࠥ ⨪  騪}
     {$IFDEF OS2}
     {३ }
     if DirExists(TapirConfig.ReadValue('BBdir','',line)) then Write('Scanning TheBrake! boxes - ');
     FindFirst(AddBackSlash(TapirConfig.ReadValue('BBdir','',line))+'*.*', Directory, SR);
       while DosError = 0 do
         begin
           if ((sr.name<>'.')and(sr.name<>'..')) then
           if sr.attr=((sr.attr) and (not archive)) then
           if CheckBB(SR.Name) then
             begin
               BBAddr(SR.Name,Address);
               if LowerCase(Address.Domain)=LowerCase(SysopAddr.Domain) then
                 begin
                   if Statistic^.Count=0 then
                     begin
                       Statistic^.Insert(New(PTapirStatRec,Init(Address)));
                       LinkRec:=Statistic^.At(Statistic^.Count-1);
                     end
                   else
                     for count:=0 to Statistic^.Count-1 do
                       begin
                         LinkRec:=Statistic^.At(Count);
                         If CompareAddr(LinkRec^.Address,Address) then Break;
                       end;
                   if not CompareAddr(LinkRec^.Address,Address) then
                     begin
                       Statistic^.Insert(New(PTapirStatRec,Init(Address)));
                       LinkRec:=Statistic^.At(Statistic^.Count-1);
                     end;

                   if LinkRec^.Flavour='' then LinkRec^.Flavour:=BBStatus(SR.Name);

                   FindFirst(AddBackSlash(TapirConfig.ReadValue('BBDir','',line))+AddBackSlash(SR.Name)+'*.*', Archive, SRB);
                     while DosError = 0 do
                       begin
                         bundle:=AddBackSlash(TapirConfig.ReadValue('BBDir','',line))+AddBackSlash(SR.Name)+SRB.Name;

                         if not (TapirConfig.ReadBoolean('UseTics',false, Line)) then
                         if LowerCase(Copy(bundle,LastPos('.',Bundle)+1,3))='tic'
                         then bundle:='';

                         if fileexists(bundle) then
                         if (IsBundle(bundle) or IsPkt(bundle) or IsUt(bundle)) then
                           begin
                             PackTime(LinkRec^.OldiestBundle, MTime);
                             Inc(LinkRec^.BundlesCount);
                             FTime:=SRB.Time;
                             if FTime<MTime then MTime:=FTime;
                             LinkRec^.BundlesSize:=LinkRec^.BundlesSize+SRB.Size;
                             UnPackTime(MTime,LinkRec^.OldiestBundle);
                           end
                         else
                           begin
                             PackTime(LinkRec^.OldiestFile, CTime);
                             Inc(LinkRec^.FilesCount);
                             FTime:=SRB.Time;
                             if FTime<CTime then CTime:=FTime;
                             LinkRec^.FilesSize:=LinkRec^.FilesSize+SRB.Size;
                             UnPackTime(CTime,LinkRec^.OldiestFile);
                           end;
                         FindNext(SRB);
                       end;
                 end;
             end;
           FindNext(SR);
         end;
     if DirExists(TapirConfig.ReadValue('BBdir','',line)) then WriteLn('Done.');
     {$ENDIF}

     {$IFNDEF DOS}
     { }
     if DirExists(TapirConfig.ReadValue('TBdir','',line)) then Write('Scanning Long T-Mail boxes - ');
     FindFirst(AddBackSlash(TapirConfig.ReadValue('TBdir','',line))+'*.*', Directory, SR);
       while DosError = 0 do
         begin
           if ((sr.name<>'.')and(sr.name<>'..')) then
           if sr.attr=((sr.attr) and (not archive)) then
           if CheckLTB(SR.Name) then
             begin
               LTBAddr(SR.Name,Address);
               Address.Domain:=SysopAddr.Domain;
               if Statistic^.Count=0 then
                 begin
                   Statistic^.Insert(New(PTapirStatRec,Init(Address)));
                   LinkRec:=Statistic^.At(Statistic^.Count-1);
                 end
               else
                 for count:=0 to Statistic^.Count-1 do
                   begin
                     LinkRec:=Statistic^.At(Count);
                     If CompareAddr(LinkRec^.Address,Address) then Break;
                   end;
               if not CompareAddr(LinkRec^.Address,Address) then
                 begin
                   Statistic^.Insert(New(PTapirStatRec,Init(Address)));
                   LinkRec:=Statistic^.At(Statistic^.Count-1);
                 end;

               if LinkRec^.Flavour='' then LinkRec^.Flavour:=LTBStatus(SR.Name);
               FindFirst(AddBackSlash(TapirConfig.ReadValue('TBDir','',line))+AddBackSlash(SR.Name)+'*.*', Archive, SRB);
                 while DosError = 0 do
                   begin
                     bundle:=AddBackSlash(TapirConfig.ReadValue('TBdir','',line))+AddBackSlash(SR.Name)+SRB.Name;

                     if not (TapirConfig.ReadBoolean('UseTics',false, Line)) then
                     if LowerCase(Copy(bundle,LastPos('.',Bundle)+1,3))='tic'
                     then bundle:='';

                     if fileexists(bundle) then
                     if (IsBundle(bundle) or IsPkt(bundle) or IsUt(bundle)) then
                       begin
                         PackTime(LinkRec^.OldiestBundle, MTime);
                         Inc(LinkRec^.BundlesCount);
                         FTime:=SRB.Time;
                         if FTime<MTime then MTime:=FTime;
                         LinkRec^.BundlesSize:=LinkRec^.BundlesSize+SRB.Size;
                         UnPackTime(MTime,LinkRec^.OldiestBundle);
                       end
                     else
                       begin
                         PackTime(LinkRec^.OldiestFile, CTime);
                         Inc(LinkRec^.FilesCount);
                         FTime:=SRB.Time;
                         if FTime<CTime then CTime:=FTime;
                         LinkRec^.FilesSize:=LinkRec^.FilesSize+SRB.Size;
                         UnPackTime(CTime,LinkRec^.OldiestFile);
                       end;
                   FindNext(SRB);
                 end;
             end;
           FindNext(SR);
         end;
     if direxists(TapirConfig.ReadValue('TBdir','',line)) then WriteLn('Done.');
     {$ENDIF}

     {⪨ }
     if DirExists(TapirConfig.ReadValue('TBdir','',line)) then Write('Scanning T-Mail boxes - ');
     FindFirst(AddBackSlash(TapirConfig.ReadValue('TBdir','',line))+'*.*', Directory, SR);
       while DosError = 0 do
         begin
           if ((sr.name<>'.')and(sr.name<>'..')) then
           if sr.attr=((sr.attr) and (not archive)) then
           if CheckSTB(SR.Name) then
             begin
               STBAddr(SR.Name,Address);
               Address.Domain:=SysopAddr.Domain;
               if Statistic^.Count=0 then
                 begin
                   Statistic^.Insert(New(PTapirStatRec,Init(Address)));
                   LinkRec:=Statistic^.At(Statistic^.Count-1);
                 end
               else
                 for count:=0 to Statistic^.Count-1 do
                   begin
                     LinkRec:=Statistic^.At(Count);
                     If CompareAddr(LinkRec^.Address,Address) then Break;
                   end;
               if not CompareAddr(LinkRec^.Address,Address) then
                 begin
                   Statistic^.Insert(New(PTapirStatRec,Init(Address)));
                   LinkRec:=Statistic^.At(Statistic^.Count-1);
                 end;
               if LinkRec^.Flavour='' then LinkRec^.Flavour:=STBStatus(SR.Name);
               FindFirst(AddBackSlash(TapirConfig.ReadValue('TBDir','',line))+AddBackSlash(SR.Name)+'*.*', Archive, SRB);
                 while DosError = 0 do
                   begin
                     bundle:=AddBackSlash(TapirConfig.ReadValue('TBdir','',line))+AddBackSlash(SR.Name)+SRB.Name;
                     if not (TapirConfig.ReadBoolean('UseTics',false, Line)) then
                     if LowerCase(Copy(bundle,LastPos('.',Bundle)+1,3))='tic'
                     then bundle:='';

                     if fileexists(bundle) then
                     if (IsBundle(bundle) or IsPkt(bundle) or IsUt(bundle)) then
                       begin
                         PackTime(LinkRec^.OldiestBundle, MTime);
                         Inc(LinkRec^.BundlesCount);
                         FTime:=SRB.Time;
                         if FTime<MTime then MTime:=FTime;
                         LinkRec^.BundlesSize:=LinkRec^.BundlesSize+SRB.Size;
                         UnPackTime(MTime,LinkRec^.OldiestBundle);
                       end
                     else
                       begin
                         PackTime(LinkRec^.OldiestFile, CTime);
                         Inc(LinkRec^.FilesCount);
                         FTime:=SRB.Time;
                         if FTime<CTime then CTime:=FTime;
                         LinkRec^.FilesSize:=LinkRec^.FilesSize+SRB.Size;
                         UnPackTime(CTime,LinkRec^.OldiestFile);
                       end;
                   FindNext(SRB);
                 end;
             end;
           FindNext(SR);
         end;
     if DirExists(TapirConfig.ReadValue('TBdir','',line)) then WriteLn('Done.');

         {show verbose information?}
         if boolean(KeyExists('/i')) then
         for count:=0 to Statistic^.Count-1 do
           begin
             LinkRec:=Statistic^.At(Count);
             WriteLn(Addr2Str(LinkRec^.Address)
             +' flavour "'+LinkRec^.Flavour
             +'", files '+IntToStr(LinkRec^.FilesCount)
             +' size '+IntToStr(LinkRec^.FilesSize)
             +', mail '+IntToStr(LinkRec^.BundlesCount)
             +' size '+IntToStr(LinkRec^.BundlesSize));
           end;


     {sorting records by size}
     Write('Sorting Link''s - ');
     Link1.Init(SysopAddr); Link2.Init(SysopAddr);
     if (SortBy='S') or (SortBy='VS') then
     for count:=2 to Statistic^.Count-1 do
       for LinkCount:=Statistic^.Count-1 downto count-1 do
         begin
           LinkRec1:=Statistic^.At(LinkCount-1);
           LinkRec2:=Statistic^.At(LinkCount);
           Link1.Address:=LinkRec1^.Address;
           Link2.Address:=LinkRec2^.Address;
           If SortBy='S' then
             if (LinkRec1^.FilesSize+LinkRec1^.BundlesSize)<
                (LinkRec2^.FilesSize+LinkRec2^.BundlesSize) then
                  begin
                    Link1.Address:=LinkRec1^.Address;
                    Link2.Address:=LinkRec2^.Address;
                    Link1:=LinkRec1^;
                    Link2:=LinkRec2^;
                    LinkRec1^:=Link2;
                    LinkRec2^:=Link1;
                  end;
           If SortBy='VS' then
             if (LinkRec1^.FilesSize+LinkRec1^.BundlesSize)>
                (LinkRec2^.FilesSize+LinkRec2^.BundlesSize) then
                  begin
                    Link1.Address:=LinkRec1^.Address;
                    Link2.Address:=LinkRec2^.Address;
                    Link1:=LinkRec1^;
                    Link2:=LinkRec2^;
                    LinkRec1^:=Link2;
                    LinkRec2^:=Link1;
                  end;
         end;

     {sorting records by address}
     if (SortBy='A') or (SortBy='VA') then
     for count:=2 to Statistic^.Count-1 do
       for LinkCount:=Statistic^.Count-1 downto count-1 do
         begin
           LinkRec1:=Statistic^.At(LinkCount-1);
           LinkRec2:=Statistic^.At(LinkCount);
           if LinkRec1^.Address.Point = 0 then AddrCount := 3 else AddrCount := 4;
           AlreadySorted := false;
           Link1.Address:=LinkRec1^.Address;
           Link2.Address:=LinkRec2^.Address;
           Link1:=LinkRec1^; Link2:=LinkRec2^;
           for strcount:=1 to AddrCount do
           case strcount of
             1:begin
                 if ((LinkRec1^.Address.Zone > LinkRec2^.Address.Zone)
                    and (not AlreadySorted) and (SortBy='A')) then
                   begin
                     LinkRec1^:=Link2; LinkRec2^:=Link1;
                     AlreadySorted := true;
                   end;
                 if ((LinkRec1^.Address.Zone < LinkRec2^.Address.Zone)
                    and (not AlreadySorted) and (SortBy='VA')) then
                   begin
                     LinkRec1^:=Link2; LinkRec2^:=Link1;
                     AlreadySorted := true;
                   end;
               end;
             2:begin
                 if ((LinkRec1^.Address.Net > LinkRec2^.Address.Net)
                    and (LinkRec1^.Address.Zone >= LinkRec2^.Address.Zone)
                    and (not AlreadySorted) and (SortBy='A')) then
                     begin
                       LinkRec1^:=Link2; LinkRec2^:=Link1;
                       AlreadySorted := true;
                     end;
                 if ((LinkRec1^.Address.Net < LinkRec2^.Address.Net)
                    and (LinkRec1^.Address.Zone <= LinkRec2^.Address.Zone)
                    and (not AlreadySorted) and (SortBy='VA')) then
                   begin
                     LinkRec1^:=Link2; LinkRec2^:=Link1;
                     AlreadySorted := true;
                   end;
               end;
             3:begin
                 if ((LinkRec1^.Address.Node > LinkRec2^.Address.Node)
                    and (LinkRec1^.Address.Net >= LinkRec2^.Address.Net)
                    and (not AlreadySorted) and (SortBy='A')) then
                   begin
                     LinkRec1^:=Link2; LinkRec2^:=Link1;
                     AlreadySorted := true;
                   end;
                 if ((LinkRec1^.Address.Node < LinkRec2^.Address.Node)
                    and (LinkRec1^.Address.Net <= LinkRec2^.Address.Net)
                    and (not AlreadySorted) and (SortBy='VA')) then
                   begin
                     LinkRec1^:=Link2; LinkRec2^:=Link1;
                     AlreadySorted := true;
                   end;
               end;
             4:begin
                 if ((LinkRec1^.Address.Point > LinkRec2^.Address.Point) and
                 (LinkRec1^.Address.Node >= LinkRec2^.Address.Node) and
                 (LinkRec1^.Address.Net >= LinkRec2^.Address.Net) and
                 (LinkRec1^.Address.Zone >= LinkRec2^.Address.Zone) and
                 (not AlreadySorted) and (SortBy='A')) then
                   begin
                     LinkRec1^:=Link2; LinkRec2^:=Link1;
                     AlreadySorted := true;
                   end;
                 if ((LinkRec1^.Address.Point < LinkRec2^.Address.Point) and
                 (LinkRec1^.Address.Node <= LinkRec2^.Address.Node) and
                 (LinkRec1^.Address.Net <= LinkRec2^.Address.Net) and
                 (not AlreadySorted) and (SortBy='VA')) then
                   begin
                     LinkRec1^:=Link2; LinkRec2^:=Link1;
                     AlreadySorted := true;
                   end;
               end;
             end;
           end;
         Link1.Done; Link2.Done;
         WriteLn('Done.');


     Write('Creating statistic - ');
     GlobalSize:=0;
     StatOut^.Insert(New(PStr,Init(MacroSubst('@Longpid v@Version'))));
     StatOut^.Insert(New(PStr,Init(MacroSubst('Copyright (c) 1999 Vladimir Zaytcev, 2:5015/116'))));
     StatOut^.Insert(New(PStr,Init(MacroSubst('[statistic for @DOW, @Date created at @Time]'))));
     StatOut^.Insert(New(PStr,Init(' ')));
     for count:=0 to Statistic^.Count-1 do
       begin
         LinkRec:=Statistic^.At(Count);
         Address:=LinkRec^.Address;
         for linkcount:=1 to TapirConfig.ValueCount('Link') do
           begin
             AddrMask(RemoveSpaces(TapirConfig.ReadValueNumber('Link','*:*/*.*',linkcount, Line)),SysopAddr, BoxAddress);
             if CompareAddr(BoxAddress, Address) then
             if ((LinkRec^.BundlesCount<>0)or(LinkRec^.FilesCount<>0)) then
               begin
                 GlobalSize:=GlobalSize+LinkRec^.FilesSize++LinkRec^.BundlesSize;
                 StatOut^.Insert(New(PStr,Init((FmtStr(LinkRec^)))));
                 SomeWritten := true;
                 Break;
               end;
           end;
       end;

         if not KeyExists('/r') then
            begin
              if SomeWritten then
                begin
                  StatOut^.AtInsert(4,New(PStr,
                  Init(('Ŀ '))));
                  StatOut^.AtInsert(5,New(PStr,
                  Init(('   Link''s information        Mail statistic           Files statistic      '))));
                  StatOut^.AtInsert(6,New(PStr,
                  Init(('Ĵ '))));
                  StatOut^.AtInsert(7,New(PStr,
                  Init(('      address      flv  b/p   size,  oldiest  files  size,  oldiest   '))));
                  StatOut^.AtInsert(8,New(PStr,
                  Init(('                       count   Kb    b/p date count   Kb    filedate  '))));
                  StatOut^.AtInsert(9,New(PStr,
                  Init(('Ĵ '))));
                  StatOut^.Insert(New(PStr,
                  Init((' '))));
                  StatOut^.Insert(New(PStr,Init(' ')));
                  if (GlobalSize div 1024)<>0
                  then StatOut^.Insert(New(PStr,Init('Totally: '+IntToStr(GlobalSize div 1024)+' Kb')))
                  else StatOut^.Insert(New(PStr,Init('Totally: 1 Kb')));
                end
              else StatOut^.Insert(New(PStr,Init('Nothing to do, sorry...')));
              StatOut^.Insert(New(PStr,Init(' ')));
              StatOut^.Insert(New(PStr,Init(MacroSubst('Thank you, @Sysop, for using @pid'))));
              StatOut^.Insert(New(PStr,Init(' ')));
            end
         else
           begin
              if SomeWritten then
                begin
                  StatOut^.AtInsert(4,New(PStr,
                  Init(('Ŀ '))));
                  StatOut^.AtInsert(5,New(PStr,
                  Init(('   ଠ       ⮢ ⨪       ⨪    '))));
                  StatOut^.AtInsert(6,New(PStr,
                  Init(('Ĵ '))));
                  StatOut^.AtInsert(7,New(PStr,
                  Init(('             䫠  . ࠧ, . . ࠧ, . '))));
                  StatOut^.AtInsert(8,New(PStr,
                  Init(('                       䠩.        䠩   䠩.        䠩    '))));
                  StatOut^.AtInsert(9,New(PStr,
                  Init(('Ĵ '))));
                  StatOut^.Insert(New(PStr,
                  Init((' '))));
                  StatOut^.Insert(New(PStr,Init(' ')));
                  if (GlobalSize div 1024)<>0
                  then StatOut^.Insert(New(PStr,Init('ᥣ: '+IntToStr(GlobalSize div 1024)+' ')))
                  else StatOut^.Insert(New(PStr,Init('ᥣ: 1 ')));
                end
              else StatOut^.Insert(New(PStr,Init(' ଠ樨  ⨪...')));
              StatOut^.Insert(New(PStr,Init(' ')));
              StatOut^.Insert(New(PStr,Init(MacroSubst('ᨡ, @Sysop,  ᯮ짮 @pid'))));
              StatOut^.Insert(New(PStr,Init(' ')));
           end;
     WriteLn('Done.');

     If( (OutType='Jam') or (OutType='Squish') or (OutType='Msg') ) then
       begin
        If OutType='Jam' then
        if not OpenOrCreateMessageBase(Base, 'J'+Output) then
        Error('Unable to open/create '+OutType);
        If OutType='Squish' then
        if not OpenOrCreateMessageBase(Base, 'S'+Output) then
        Error('Unable to open/create '+OutType);
        If OutType='Msg' then
        if not OpenOrCreateMessageBase(Base, 'M'+Output) then
        Error('Unable to open/create '+OutType);

        if not Base^.CreateNewMessage then  WriteLn('Unable to create New message')
        else
          begin
            Write('Posting to ',OutType,' - ');
            StrToAddress(TapirConfig.ReadValue('FromAddr',Addr2Str(SysopAddr),Line), FromAddr);
            StrToAddress(TapirConfig.ReadValue('ToAddr',Addr2Str(SysopAddr),Line), ToAddr);
            Base^.SetFromAddress(FromAddr, True);
            Base^.SetToAddress(ToAddr);
            Base^.SetFrom(MacroSubst(TapirConfig.ReadValue('FromName','@pid',Line)));
            Base^.SetTo(MacroSubst(TapirConfig.ReadValue('ToName','All',Line)));
            Base^.SetSubject(MacroSubst(TapirConfig.ReadValue('Subject','  㦨 ᪨?',Line)));

            GetCurrentMessageBaseDateTime(T);
            Base^.SetWrittenDateTime(T);
            Base^.SetArrivedDateTime(T);
            Base^.SetAttribute(maLocal, True);
            Base^.PutString(MacroSubst(#1+'PID: @pid @version'));

            for count:=0 to StatOut^.Count-1 do
              begin
                Str:=StatOut^.At(count);
                Base^.PutString(Str^.Value);
              end;

            Address.Zone:=FromAddr.Zone; Address.Net:=FromAddr.Net;
            Address.Node:=FromAddr.Node; Address.Point:=FromAddr.Point;
            Base^.PutString('--- '+MacroSubst(TapirConfig.ReadValue('Tearline','@pid',Line)));
            Base^.PutString(' * Origin: '+MacroSubst(TapirConfig.ReadValue('Origin','@pid',Line))+' ('
            +Addr2Str(Address)+')');
            if not Base^.WriteMessage then WriteLn('Unable to write message');
            Base^.CloseMessage;
            if not CloseMessageBase(Base) then  Error('unable to close '+OutType);

            WriteLn('Done.');
         end;
       end;


     If OutType='File' then
       begin
         Write('Writing statistic - ');
         if LowerCase(TapirConfig.ReadValue('Mode','Overwrite',Line))='overwrite'
         then TapirOut.Create(Output,true) else TapirOut.Create(Output,false);
         for count:=0 to StatOut^.Count-1 do
           begin
             Str:=StatOut^.At(count);
             TapirOut.WriteString(Str^.Value);
             StrCount:=StrCount+SizeOf(Str^.Value)+SizeOf(Str);
           end;
         TapirOut.Free;
         WriteLn('Done.');
       end;

     Dispose(StatOut, Done);
     Dispose(Statistic, Done);
     TapirConfig.Free;
     TextColor(7);

  end
 else
  begin
    ClrScr; ShowHeader;
    TextColor(15);
    WriteLn('(c) 1999, Vladimir Zaytcev, fidonet 2:5015/116, e-mail: omni_@iname.com');
    WriteLn('(pc) 1999, Maxim Zharkov, fidonet 2:5015/116 2:5015/116.4');
    TextColor(7);
  end
 else
  begin
    ClrScr; ShowHeader;
    TextColor(15);
    WriteLn('Availiable cmd-line keywords is:');
    TextColor(14);WriteLn;
    WriteLn('/c:<config>     - <config> is config filename');
    WriteLn('/out:<outfile>  - <outfile> is filename for statistic output');
    WriteLn('/r              - create statistic in russian');
    WriteLn('/about          - about autor''s');
    WriteLn('/?              - this help');
    TextColor(7);
  end;
end.
